WinGRASS 6 Current Status

From GRASS-Wiki
Revision as of 22:38, 27 June 2013 by HamishBowman (talk | contribs) (Major)

Jump to: navigation, search

This page describes the current status of winGRASS development as of mid-2013


Current status - Summary

The native windows port of GRASS is slowly coming to a stage where it can be considered mature beta status. All main functions seem to work, but much more testing is needed. The port is of the current SVN release branch for GRASS 6.4. The only prior native port of an earlier version is 6.3.0.

The general idea is to reach a point where GRASS runs in MS-Windows without any kind of UNIX emulation. Currently this is possible but limits the use to compiled modules, as scripts are all of UNIX-shell type and cannot run within a Windows cmd.exe environment without a series of UNIX tools such as a shell, awk, sed, etc. So in order to run such scripts a collection of UNIX-like tools needs to be installed, such as Msys or Gnuwin32+Shell.

Another major feature not available in the MS-Windows version are the old-style interactive X monitors (i.e. the x0 monitors opened with 'd.mon x0'). Only direct rendering works currently. Display is thus "limited" to the wxPython and Tcl/Tk GUIs. Modules like i.points and d.zoom will not work due to their interactive monitor requirements (see #Known_Issues).

Installing binary snapshots

Regular binary snapshots for windows are available from the main GRASS download page.

Compiling by yourself

Guide

All the information needed for compiling yourself can be found in Compiling GRASS on MS-Windows

See also BuildingOnWindows


Nullsoft installer

See http://trac.osgeo.org/grass/browser/grass/branches/develbranch_6/mswindows

New winGRASS installer 1 New winGRASS installer 2 New winGRASS installer 3

  • Note the "Important Microsoft Runtime Libraries" option. Some of the software which ships with GRASS will not run if these system libraries are not already present, and unfortuantely Microsoft does not install them by default, you need to install the .Net framework or Visual C++ compiler runtime support to get them. These libraries are not part of GRASS but we give the user the opportunity to download and install them during the install if they are needed. Typically a computer with a lot of software already installed may have them, a new computer is likely to be missing them. If they are not installed the symptom is that the GRASS window momentarily flashes on the screen then disappears at start up, closing before you can see the error message.

Known Issues

See also

General

  • Spaces in path names
    • GIS data directory: It is generally safe to have spaces in your GIS data directory path, but there are few spots where it might still get confused and chop the path off at the first space. If you find one please report it to the bug tracker, the sooner we know about it the sooner we can fix it.
Workaround: if this is causing problems for you the quick solution is to rename the GIS data directory and replace all spaces with underscores (_).
  • The r.li suite and d.mon Xmonitors won't work. These use UNIX pipes and won't work on Windows without a lot of work.

Won't fix (at least not immediately)

Issues listed here are rather impossible to fix due to the different nature of native Windows. Or, lend us a hand and let's try harder!

  • No monitors

This means that you cannot launch any monitor launched with d.mon (x0, PNG, PS, etc). The only way you can render is directly to a file. But you cannot directly display to screen from the command line. This will be solved in GRASS 7 with a new rendering system and possibly via the new wxgrass GUI. So no work will probably be put into this until then.

The absence of monitors also makes impossible the use of interactive modules based on these monitors, such as:

    • i.class. However, it has been integrated into GRASS 7 wxGUI in January 2012 (winGRASS 7)
    • i.ortho.photo/photo.2image
    • i.ortho.photo/photo.2target
    • i.points
    • i.vpoints

i.points and i.vpoints have already been replaced by the gis.m georectifier module (File -> Georectify). In replacement of i.class you can digitize training areas with v.digit. This will not however, give you all the information i.class provides, such as the histogram of the region, the statistics and the display of matches. These modules will have to be rewritten to clearly separate display and backend parts, so that the backend can be run on the command line or from any GUI frontend. Volunteers needed.

Another module affected is d.vect.thematic which uses monitors. This will hopefully be replaced by a C-version in a not too far future.

  • Scripts need *nix-like shell

All current GRASS 6.4 scripts are written in shell language. This means they need a shell, and several related tools (awk, sed, etc), to function. The actual WinGrass 6.4-installer includes Msys, so all shell-scripts should work.

In 7.0, these scripts have been rewritten in Python, thus totally eliminating the need for any shell.

Missing modules

  • The r.li landscape structure analysis suite: not ported yet
  • The r.le landscape modelling suite:
    • r.le.setup, r.le.trace: not ported yet
    • r.le.pixel, r.le.patch: available
  • Some GUI helper scripts such as g.change.gui.py and v.type.py
    • v.type => in the wx-command-line choice confusion of v.type, 1x v.type_wrapper.py and 3x v.type_wrapper.sh
    • v.type_wrapper.py crashes
  • The wxnviz 3D visualization module for the new wxGUI. Use NVIZ available from the old Tcl/Tk GIS.m GUI instead.
  • v.out.gpsbabel fails to start m.proj although present
  • GRASS GIS Cartographic Composer → Preview fails
  • i.ortho.photo => greyed out, requires xterm unavailable in MS-Windows
  • i.class => greyed out, requires xterm unavailable in MS-Windows
  • r.digit => greyed out, requires xterm unavailable in MS-Windows
  • v.krige.py => greyed out

Platform specific issues

XP/2000

If the GRASS GUI startup fails with "[Error 14001]" in the MSys terminal on a relatively fresh install of XP, the solution is to install some missing DLL files from Microsoft which apparently don't come standard. If these library files are missing, Quantum GIS and other software from the OSGeo4W stack will likely encounter the same trouble as well.

You'll need to install a number of packages: (in order)

  • MS's Windows Installer 3.1 Redistributable (v2)
http://www.microsoft.com/download/en/details.aspx?displaylang=en&id=25
  • MS's .net framework 3.5 downloader
http://www.microsoft.com/download/en/details.aspx?id=21
  • MS's Visual C++ 2010 Redistributable Package:
http://www.microsoft.com/en-us/download/details.aspx?displaylang=en&id=5555

It is recommended to run Windows updates after installing these.

Windows7

  • Missing MSVCR71.dll or MSVCP100.dll library causes GRASS to exit immediately upon startup.
Try installing Microsoft's .net frameworks as described above in the XP section to get the various Visual C++ Redistributables. You can download them here and for MSVCP100.dll here. (Install redistributable first, main package second, and service pack third)
If that doesn't solve it, try these instructions found in a web search: http://i.justrealized.com/2009/how-to-fix-missing-msvcr71dll-problem-in-windows/
Unfortunately we can't legally distribute Microsoft's library with GRASS directly.

ToDo

Dependencies

GRASS Dependencies
  • add the FFMPEG support in GRASS (reports an error in building OGSF library; probably needs to specify -lavutil in gcc command) ***
Non-Free GDAL Plugins

(can't be shipped as part of the GRASS package directly due to various levels of non-freeness, but can be made into user-installable plugins)

  • ECW support in GDAL */**
  • JPEG2000 support in GDAL (through Jasper or Kadaku *) **
  • OGDI support in GDAL *
  • MrSID support in GDAL */**
GRASS and GDAL Dependencies
  • add the Xerces support in both GDAL and GRASS *
  • add the ODBC support in both GDAL and GRASS */**
  • add the MySQL support in both GDAL and GRASS */**
Miscellaneus Dependencies
  • add the OpenSSL support in both PostgreSQL and SQLite *


* needs to build related libraries from source in MinGW
** needs to check the licences first
*** FFMPEG has been already succesfully built on MinGW

Internal Libraries

  • parser: find out why launching a module from the command line without parameters does not call module GUI

Vector modules

  • v.in.ascii crashes on files with irregular line length (see this thread)

Raster modules

  • The wxGUI has an issue when trying to run r.mapcalc with the || "or" operator from the wxGUI built-in command entry box on the command console tab of the Layer Manager. You can work around this by running r.mapcalc using the Map Calculator GUI, or from a real command line (in that case remember to "quote" the expression).
  • The same wxGUI built-in command entry box on the command colsole tab requires file names with paths to be fully "quoted", e.g. input="C:\data\positions.csv", or else the "\" characters are lost.

Other modules

  • r.li moduels do not compile (they require UNIX sockets, much the same situation as the display monitors)
Use the older r.le modules instead.

GRASS Addons

  • Not all the GRASS Addons are available from the wxGUI extension manager. Problems still exist with running Python scripts. The command line version of g.extension requires the full osgeo4w build environment, which is not installed on most Windows users' computers, so you need to use the pre-built downloads from the wxGUI extension tool.

Tcl/Tk issues

Miscellaneous

  • metacharacter escape in "sh -c '$cmd'"
  • modules not working: v.neighbors, v.kernel, r.cost
  • Cannot open Help pages.
  • Have to type "exit" in the console to save ~/.grassrc file. Then, close gis.m to finish the session.
  • A previous installation of grass under cygwin is likely to cause problems with WinGrass. Follow the directions to remove cygwin at http://cygwin.com/faq/faq-nochunks.html#faq.setup.uninstall-all

The following items cannot be fixed in the near future:

    • can't read "_data(.gronsole.gronsole,4,donecmd)": no such element in array error
      • Could you be more precise about this error ? When does it occur ?

Dealing with shell scripts or .bat files

Bourne shell scripts require MSys (or some other Bourne shell), but you don't need to start GRASS from MSys.

The main issue with scripts is that Windows doesn't understand the "#!" notation used to specify the interpreter.

All of the supplied scripts in $GISBASE/scripts have a corresponding .bat file in $GISBASE/bin which invokes script via %GRASS_SH%. This allows you to run those scripts from the Windows command prompt.

If you write scripts of your own, you need to either add a corresponding .bat file, or give the script a .sh extension and associate that with the shell, e.g. via the ftype and assoc commands. You can use the PATHEXT variable to eliminate the need to type the extension.

Other libraries

GDAL

  • lib/gis/OBJ.*/fmode.o is needed for any GRASS related modules.
  • modified ltmain.sh to install binary files from wrapper scripts.
  • see also GDAL Building With MinGW

Related efforts